Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.http.nio.protocol
Class BasicAsyncResponseProducer

    java.lang.Object
      org.apache.http.nio.protocol.BasicAsyncResponseProducer

All Implemented Interfaces:
  Closeable, HttpAsyncResponseProducer

    public class BasicAsyncResponseProducer

extends Object
implements HttpAsyncResponseProducer

Basic implementation of `HttpAsyncResponseProducer`. The producer can make use of the `HttpAsyncContentProducer` interface to efficiently stream out message content to the underlying non-blocking HTTP connection, if it is implemented by the `HttpEntity` inclosed in the response.

Since:
  4.2
See Also:
  `HttpAsyncContentProducer`

Constructor Summary
`` | `BasicAsyncResponseProducer(HttpResponse response)` Creates a producer that can be used to transmit the given response message.
`protected` | `BasicAsyncResponseProducer(HttpResponse response, HttpAsyncContentProducer producer)` Creates a producer that can be used to transmit the given response message.

Method Summary
`void` | `close()`
`void` | `failed(Exception ex)` Invoked to signal that the response processing terminated abnormally.
`HttpResponse` | `generateResponse()` Invoked to generate a HTTP response message head.
`void` | `produceContent(ContentEncoder encoder, IOControl ioControl)` Invoked to write out a chunk of content to the `ContentEncoder`.
`void` | `responseCompleted(HttpContext context)` Invoked to signal that the response has been fully written out.
`String` | `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### BasicAsyncResponseProducer

    protected BasicAsyncResponseProducer(HttpResponse response,
                                         HttpAsyncContentProducer producer)

  Creates a producer that can be used to transmit the given response message. The given content producer will be used to stream out message content. Please note that the response message is expected to enclose an `HttpEntity` whose properties are consistent with the behavior of the content producer.

  Parameters:
    `response` - response message.
    `producer` - response content producer.

### BasicAsyncResponseProducer

    public BasicAsyncResponseProducer(HttpResponse response)

  Creates a producer that can be used to transmit the given response message. If the response message encloses an `HttpEntity` it is also expected to implement `HttpAsyncContentProducer`.

  Parameters:
    `response` - response message.

Method Detail

### generateResponse

    public HttpResponse generateResponse()

  Description copied from interface: `HttpAsyncResponseProducer`
  Invoked to generate a HTTP response message head.

  Specified by:
    `generateResponse` in interface `HttpAsyncResponseProducer`
  Returns:
    HTTP response message.

### produceContent

    public void produceContent(ContentEncoder encoder,
                               IOControl ioControl)
                        throws IOException

  Description copied from interface: `HttpAsyncResponseProducer`
  Invoked to write out a chunk of content to the `ContentEncoder`. The `IOControl` interface can be used to suspend output event notifications if the producer is temporarily unable to produce more content.

  When all content is finished, the producer MUST call `ContentEncoder.complete()`. Failure to do so may cause the entity to be incorrectly delimited.

  Please note that the `ContentEncoder` object is not thread-safe and should only be used within the context of this method call. The `IOControl` object can be shared and used on other thread to resume output event notifications when more content is made available.

  Specified by:
    `produceContent` in interface `HttpAsyncResponseProducer`
  Parameters:
    `encoder` - content encoder.
    `ioControl` - I/O control of the underlying connection.
  Throws:
    `IOException` - in case of an I/O error

### responseCompleted

    public void responseCompleted(HttpContext context)

  Description copied from interface: `HttpAsyncResponseProducer`
  Invoked to signal that the response has been fully written out.

  Specified by:
    `responseCompleted` in interface `HttpAsyncResponseProducer`
  Parameters:
    `context` - HTTP context

### failed

    public void failed(Exception ex)

  Description copied from interface: `HttpAsyncResponseProducer`
  Invoked to signal that the response processing terminated abnormally.

  Specified by:
    `failed` in interface `HttpAsyncResponseProducer`
  Parameters:
    `ex` - exception

### close

    public void close()
               throws IOException

  Specified by:
    `close` in interface `Closeable`
  Throws:
    `IOException`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.